<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsultarAdministracionesResponse StructType
 * @subpackage Structs
 */
class ConsultarAdministracionesResponse extends AbstractStructBase
{
    /**
     * The resultado
     * @var \StructType\Resultado
     */
    public $resultado;
    /**
     * The administraciones
     * Meta information extracted from the WSDL
     * - arrayType: tns:UnidadDir3[]
     * - base: soap-enc:Array
     * - nillable: true
     * - ref: soap-enc:arrayType
     * @var \StructType\UnidadDir3[]
     */
    public $administraciones;
    /**
     * Constructor method for ConsultarAdministracionesResponse
     * @uses ConsultarAdministracionesResponse::setResultado()
     * @uses ConsultarAdministracionesResponse::setAdministraciones()
     * @param \StructType\Resultado $resultado
     * @param \StructType\UnidadDir3[] $administraciones
     */
    public function __construct(\StructType\Resultado $resultado = null, array $administraciones = array())
    {
        $this
            ->setResultado($resultado)
            ->setAdministraciones($administraciones);
    }
    /**
     * Get resultado value
     * @return \StructType\Resultado|null
     */
    public function getResultado()
    {
        return $this->resultado;
    }
    /**
     * Set resultado value
     * @param \StructType\Resultado $resultado
     * @return \StructType\ConsultarAdministracionesResponse
     */
    public function setResultado(\StructType\Resultado $resultado = null)
    {
        $this->resultado = $resultado;
        return $this;
    }
    /**
     * Get administraciones value
     * @return \StructType\UnidadDir3[]|null
     */
    public function getAdministraciones()
    {
        return $this->administraciones;
    }
    /**
     * This method is responsible for validating the values passed to the setAdministraciones method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdministraciones method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdministracionesForArrayConstraintsFromSetAdministraciones(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $consultarAdministracionesResponseAdministracionesItem) {
            // validation for constraint: itemType
            if (!$consultarAdministracionesResponseAdministracionesItem instanceof \StructType\UnidadDir3) {
                $invalidValues[] = is_object($consultarAdministracionesResponseAdministracionesItem) ? get_class($consultarAdministracionesResponseAdministracionesItem) : sprintf('%s(%s)', gettype($consultarAdministracionesResponseAdministracionesItem), var_export($consultarAdministracionesResponseAdministracionesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The administraciones property can only contain items of type \StructType\UnidadDir3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set administraciones value
     * @throws \InvalidArgumentException
     * @param \StructType\UnidadDir3[] $administraciones
     * @return \StructType\ConsultarAdministracionesResponse
     */
    public function setAdministraciones(array $administraciones = array())
    {
        // validation for constraint: array
        if ('' !== ($administracionesArrayErrorMessage = self::validateAdministracionesForArrayConstraintsFromSetAdministraciones($administraciones))) {
            throw new \InvalidArgumentException($administracionesArrayErrorMessage, __LINE__);
        }
        $this->administraciones = $administraciones;
        return $this;
    }
    /**
     * Add item to administraciones value
     * @throws \InvalidArgumentException
     * @param \StructType\UnidadDir3 $item
     * @return \StructType\ConsultarAdministracionesResponse
     */
    public function addToAdministraciones(\StructType\UnidadDir3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UnidadDir3) {
            throw new \InvalidArgumentException(sprintf('The administraciones property can only contain items of type \StructType\UnidadDir3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->administraciones[] = $item;
        return $this;
    }
}
